// inspired by a Levi Jannsen video
// https://www.youtube.com/watch?v=jQ6LQBFZXmU
// also inspired by Dan Fekete video and code
// https://www.youtube.com/watch?v=FdTGeYKB5NM

// main disc some fraction of total gear reduction
total_gear_reduction = 10; 
main_disc_d = 5 * total_gear_reduction;

// making in smaller
main_disc_d_offset = 2/3; // downsizing, e.g. 2/3
main_disc_d = main_disc_d * main_disc_d_offset;

// tangent circle defines the point rolling around
tanget_circle_d = main_disc_d / total_gear_reduction; 

module cycloid_gear() {
 render() difference() {
  cycloid(N=i, base_circ_r=(D*i/N)/2, pin_d=d_p, e=e, h=th);
  translate([0,0,-.5])
   radial_pins(n=n,ref_d=d_d,d=d_rb,th=th+1); // roller pin bores
 }
}

// Ring Pin reference circle diameter
D = 45;
// Number of ring pins
N = 10;
// Pin diameter
d_p = 5;
// eccentricity
//e = 0.3*d_p;
e = 1;

// Number of rolling pins
n = 4;
// Roller Pin diameter
d_r = 3;
// Roller Pin bore
d_rb = d_r + 2*e;
// Roller Pin reference circle diameter
d_d = 25;

// gear thickness
th = 5;
