number_of_holders = 10;
roller_diameter = 360/number_of_holders;
pin_diameter = (360/number_of_holders)/2+1;
holder_spike_hole_size = 6.5;
spike_hole_size = holder_spike_hole_size - 2.5; 
knob_plate_size = 15;
knob_plate_hole_size = 15+9;
spring_hole_size = 7;
cycloid_wedge_extrude = [0.4:0.01:1];
connector_hole_sz = 3;

$fn=25;


module cycloid(d=45){
    big_circle_cycloid = d+5;
    difference(){
        circle(d);
            for(a=[1:360/number_of_holders:360]){
                rotate([0,0,a])
                translate([0,big_circle_cycloid,0])   
                    circle(d/4);
            }
    }        
            
            for(a=[pin_diameter:360/number_of_holders:360]){
                rotate([0,0,a])
                translate([0,big_circle_cycloid * 0.86,0])   
                    circle(d/9);
            }
}        


module holder_spike(lenght=30,diameter=4,distance=24,number=3){
    for(a=[1:360/number:360]){
                    rotate([0,0,a])
                    translate([0,distance,0])
                    linear_extrude(lenght)
                        circle(diameter);
    }
    for(a=[1:360/number:360]){
                    rotate([0,0,a])
                    translate([0,distance,0])
                        sphere(diameter);
    }
}

// female cycloid holder
// shared variables with male cycloid holder not implemented
translate([0,0,1])
difference(){
    difference(){    
        cylinder(44,50,50);
        
        translate([0,0,-9])
        for(h=[0.2:0.01:1]){
            translate([0,0,h*50])
                scale([h,h,1])
                linear_extrude(5)
                cycloid(45);
        }
    }
    
    // hole for knob mechanism
    translate([0,0,-1])
    linear_extrude(knob_plate_hole_size)
    circle(knob_plate_hole_size);
}
    // handle
    translate([-50,-17,1])
    linear_extrude(44)
    circle(10);


/*color("blue")
difference(){
    circle(50);
    circle(10);
    }*/

// springholder
spring_length=36;
spring_socket=spring_length/4;    
translate([100,0,100-spring_length-spring_socket])  
    color("orange")
        linear_extrude(spring_length)
        circle(3);
// socket for spring holder
translate([100,0,100-(spring_socket)])  
    color("brown")
        linear_extrude(spring_socket)
        circle(10);
    
difference(){
    difference(){
        difference(){
            
            // male cycloid holder, pyramid wedge holder
            translate([100,0,-15])
                color("lightblue")
                for(h=[0.2:0.01:1]){
                    translate([0,0,h*50])
                        scale([h,h,1])
                        linear_extrude(5)
                        cycloid(45);
                }
            // spring hole cutout    
            translate([100,0,13])
                color("blue")
                linear_extrude(35)
                circle(spring_hole_size);   
        }
            // deep spring hole cutout  
            translate([100,0,0])
                color("green")
                linear_extrude(13.1)
                circle(spring_hole_size * 0.75);   
    }

// holder spike holes  
translate([100,0,-20])
    holder_spike(100,diameter=holder_spike_hole_size);
}

// knob plate
for(h=[1:0.25:knob_plate_size]){
    translate([100,0,knob_plate_size/2*0.75*-1-h])
        color("lightblue")
        linear_extrude(knob_plate_size-h*0.75)
        scale([1.5,1.5,0.5])
        circle(h);
    }
// knob bubble
    translate([100,0,(knob_plate_size*0.75+6)*-1])
        color("lightgrey")
        scale([1.5,1.5,0.5])
        sphere(5);

// right side
// grey circle
translate([100,0,100])
    color("grey")
    linear_extrude(5)
    scale([1,1,1])
    circle(50);

// holder spikes
translate([100,0,60])
    holder_spike(40,number=3, diameter=spike_hole_size);
translate([100,0,97])
    holder_spike(3,number=3,diameter=8);

// blue disk hole
translate([100,0,-10])
    color("blue")
    linear_extrude(5)
    difference(){
        circle(50);
        circle(knob_plate_hole_size);
        }
 
// holder connector on blue disk       
 difference(){       
    translate([150,0,-10])
        color("lightgrey")
        scale([1.4,1,1])     
        linear_extrude(5)
            circle(15);
    // hole in the connector       
    translate([160,0,-20])
        color("grey")   
        linear_extrude(150)
            circle(connector_hole_sz);
}        

// handle
handle_pos=180;
handle_length=70;
translate([20,0,0])
    difference(){
        translate([handle_pos,0,-5])
            color("lightgreen")
            linear_extrude(handle_length)
                circle(10);

        translate([handle_pos,0,-20])
            color("grey")   
            linear_extrude(150)
                circle(connector_hole_sz);
    }        

// handle connector on gray disk
difference(){
    translate([150,0,100])
        color("lightgrey")
        scale([1.4,1,1])    
        linear_extrude(5)
            circle(15);
    // hole in the connector
    translate([160,0,-20])
        color("grey")   
        linear_extrude(150)
            circle(2);        
}

/*for(a=[1:360/3:360]){
                rotate([0,0,a])
                translate([0,24,0])
                linear_extrude(30)
                    circle(5);
}

translate([100,0,70])
for(a=[1:360/3:360]){
                rotate([0,0,a])
                translate([0,24,0])
                    sphere(5);
}
*/


/*linear_extrude(height=25, center=true, convexity=10, twist=-12.5){
    cycloid();
    //translate([15,45,0])
    //circle(7.5);
    }

/*translate([0,-5,10])
    rotate([0,0,90])
    color("lightblue")
    cycloid();*/

/*translate([-6,44,0])
rotate([0,-10,0])
linear_extrude(height = 25, center = true, convexity = 10, twist = -500){
    translate([1.5,2,0])
        color("blue")
        circle(5);
}*/