//
// Hypocycloid gear reduce for a NEMA 14 motor.
//	3/17/13      -jkl
//
// TODO:
// - lower case half DONE
// - upper case half - NEED M3 and head recesses - check bolt length!!
///// Add M3 heads to NEMA14 model with switch to turn on. ////
// - rotor with 2 10x15x4 bearings DONE
// - output block with 5x10x4 bearing and M5 bolt DONE
// - input shaft 10mm with 5mm opening and 1.5mm eccentric DONE
// 
// Design needs: 
// - dimension stackup - NEED M5 Dims
// - taper overhangs for printing as needed (only on output block now) DONE
// - NEMA14 model - OK, but needs fixing. DONE
// - bearing models DONE
// - output bolt model DONE
//

showAssy = 1;		// set to 1 to show the assembly, 0 to print parts
show = 1;		// set to zero to suppress cut-outs
explode = 1; 	// set to 1 to spread assembly apart
showMotor = 0;	// set to one to show NEMA14 motor
show_bearings = 1; // set to one to show bearings (ghosted).
show_bolts = 1;
// turn these on one at a time for stls.
print_Lower = 0;
print_Upper = 0;
print_Input = 0;
print_Output = 0;
print_Rotor = 0;

module lowerCase()
{
	difference() {
		union() {
	
			difference() {
				translate(-[18,18,0])
				cube([36,36,16]);
				translate([0,0,-1]) rotate([0,0,0]) cylinder(r=11.2,4.6,center=false,$fn=30);
				translate([0,0,3.5]) rotate([0,0,0]) cylinder(r=16.2,20,center=false,$fn=30);
			}
			translate([0,0,3.5])
			linear_extrude(height = 5, center = false, convexity = 10, $fn = 100)
			import("testp4cBRoller1213.dxf");
		}
		translate([-18,18,0]) rotate([180,0,0]) NEMA14();
	if (show == 1){
		translate([0,0,-1]) rotate([0,0,-44])
		//cube([20,20,40]);		// just used for viewing
		linear_extrude(height = 20, center = false, convexity = 10, $fn = 100)
		triangle();
		translate([0,0,-1]) rotate([0,0,0])
		linear_extrude(height = 20, center = false, convexity = 10, $fn = 100)
		triangle();
		translate([0,0,-1]) rotate([0,0,44])
		linear_extrude(height = 20, center = false, convexity = 10, $fn = 100)
		triangle();
	}
	}
}

module rotor()
{
	difference(){
		union() {
				linear_extrude(height = 5, center = false, convexity = 10, $fn = 100)
				import("testp4cBCam1213.dxf");
				translate([0,0,6])
				linear_extrude(height = 5, center = false, convexity = 10, $fn = 100)
				import("testp3eBCam1213.dxf");
			difference() {
				//This union adds a shoulder for 10mm bearings
				union(){
					translate([-1.5,0,5]) rotate([0,0,0]) cylinder(r=11.5,1,center=false,$fn=30);
					translate([-1.5,0,5]) rotate([0,0,0]) cylinder(r=8,2,center=false,$fn=30);
				}
				translate([-1.5,0,4]) rotate([0,0,0]) cylinder(r=6,5.5,center=false,$fn=30);
				translate([-1.5,0,1]) bearing10x15x4(clearance=1);
				translate([-1.5,0,7]) bearing10x15x4(clearance=1);
			}
		}
	if (show == 1){
		translate([0,0,-1]) rotate([0,0,44])
		linear_extrude(height = 20, center = false, convexity = 10, $fn = 100)
		triangle();
	}
	}
}
module outputBlock()
{
	difference() {
		union() {
			//translate([0,0,10])
			linear_extrude(height = 5, center = false, convexity = 10, $fn = 100)
			import("testp3eBRoller1213.dxf");
			translate([0,0,5]) rotate([0,0,0]) cylinder(r=15.5,1.5,center=false,$fn=100);
			translate([0,0,6.5]) rotate_extrude($fn=100)
			polygon( points=[[0,0],[15.5,0],[15.5,1],[7,9],[0,9]] );
		}
		translate([0,0,0]) rotate([0,0,0]) cylinder(r=3.5,21.5,center=false,$fn=30);
		translate([0,0,5]) bearing5x10x4(clearance=1);
		translate([0,0,12]) rotate([0,0,0]) M5bolt();
	if (show == 1){
		translate([0,0,-1]) rotate([0,0,0])
		linear_extrude(height = 20, center = false, convexity = 10, $fn = 100)
		triangle();
		translate([0,0,-1]) rotate([0,0,44])
		linear_extrude(height = 20, center = false, convexity = 10, $fn = 100)
		triangle();
	}
	}
}

//!!!!!!!!!!!!!! must check case height and set "heads" correctly !!!!!!!!!!!!!
// Currently 32mm, so 35mm screws are perfect.
module upperCase()
{
	difference() {
		union() {
			difference() {
				translate(-[18,18,0])
				cube([36,36,16]);
				//translate([0,0,-1]) rotate([0,0,0]) cylinder(r=13,4.6,center=false,$fn=30);
				translate([0,0,3]) rotate([0,0,0]) cylinder(r=16.2,20,center=false,$fn=30);
				translate([0,0,-1]) rotate([0,0,0]) cylinder(r=3.5,10,center=false,$fn=30);
				translate([0,0,1]) bearing5x10x4(clearance=1);
			}
		}
		translate([-18,18,0]) rotate([180,0,0]) NEMA14(heads = 0, face = 0); 
	if (show == 1){
		translate([0,0,-1]) rotate([0,0,89])
		//cube([20,20,40]);		// just used for viewing
		linear_extrude(height = 20, center = false, convexity = 10, $fn = 100)
		triangle();
		translate([0,0,-1]) rotate([0,0,0])
		linear_extrude(height = 20, center = false, convexity = 10, $fn = 100)
		triangle();
		translate([0,0,-1]) rotate([0,0,44])
		linear_extrude(height = 20, center = false, convexity = 10, $fn = 100)
		triangle();
	}
	}
}

module inputShaft()
{
	difference(){
		union(){
			cylinder(r=12/2,1,center=false,$fn=30);	// 1mm base, 12 mm dia
			translate([0,0,1]) cylinder(r=9.8/2,10,center=false,$fn=30);	// <10 mm shaft, ?? mm long??
			translate([1.5,0,11]) cylinder(r=6/2,0.2,center=false,$fn=30);	// Inner Race Shoulder
		}
		translate([1.5,0,-1])  cylinder(r=4.7/2,22,center=false,$fn=30);		// <5mm hole
	}
}

module triangle()
{
	polygon( points=[[0,0],[30,0],[30,30],[0,0]] );
}
// This is not bad, but needs accurate length for shaft DONE
// and single screw holes DONE
// and center ring height DONE
// and screw lengths NO NEED
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// NEMA 14 Motor Model
// Make all cutouts, etc. solid and then subtract the motor.
module NEMA14(heads = 0, face = 1, show_mot = 0){
	difference(){
		union(){
		//	if (show_motor ==1){
		//	  #translate([0,0,0]) cube([36,36,20]);	// Motor Body
		//	}	
		//	else {
				  translate([0,0,0]) cube([36,36,20]);	// Motor Body
		//	}
		if (face == 1) {
			translate([18,18,0]) rotate([0,180,0]) cylinder(r=2.5,21.5,center=false,$fn=30);
			translate([18,18,0]) rotate([0,180,0]) cylinder(r=11.2,3.5,center=false,$fn=30);
		}
			translate([5,5,0.1]) rotate([0,180,45]) slot_hole(head = heads);
		if (show_mot == 0) {
			translate([31,5,0.1]) rotate([0,180,45]) slot_hole(head = heads);
		}
			translate([5,31,0.1]) rotate([0,180,45]) slot_hole(head = heads);
			translate([31,31,0.1]) rotate([0,180,45]) slot_hole(head = heads);
			// the following just checks centering
			/*
			translate([18,18,0]) difference(){
				cylinder(r=18.4,h=1);
				cylinder(r=18.2,h=2);
			}
			*/
		}
	}
}
// Modified to just be a single hole
// slotted hole for a motor mount
module slot_hole(head = 0){
	difference(){
		union(){
			translate([0,0,0]) cylinder(r=1.8,40,center=false,$fn=30);
		if (head == 1) {
			translate([0,0,0]) cylinder(r=2.8,3.5,center=false,$fn=30);
		}
			//translate([-2,0,0]) cylinder(r=1.8,10,center=false,$fn=30);
			//translate([2,0,0]) cylinder(r=1.8,10,center=false,$fn=30);
			//translate([-2,-1.8,0]) cube([4,3.6,10]);
		}
	}
}

module bearing5x10x4(clearance=0){
	if (clearance == 0) {
		difference(){
			cylinder(r=10/2,4,center=false,$fn=30);
			translate([0,0,-1]) cylinder(r=5/2,4+2,center=false,$fn=30);
		}
	} else {
		difference(){
			union(){
				cylinder(r=(10+0.2)/2,4,center=false,$fn=30);
				translate([0,0,-0.2]) cylinder(r=9/2,4+0.4,center=false,$fn=30);
			}
			//translate([0,0,-1]) cylinder(r=5/2,4+2,center=false,$fn=30);
		}
	}
}

module bearing10x15x4(clearance=0){
	if (clearance == 0) {
		difference(){
			 cylinder(r=15/2,4,center=false,$fn=30);
			translate([0,0,-1]) cylinder(r=10/2,4+2,center=false,$fn=30);
		}
	} else {
		difference(){
			union(){
				cylinder(r=(15+0.2)/2,4,center=false,$fn=30);
				translate([0,0,-0.2]) cylinder(r=14/2,4+0.4,center=false,$fn=30);
			}
			//translate([0,0,-1]) cylinder(r=10/2,4+2,center=false,$fn=30);
		}
	}
}

module M5bolt(){
	union(){
		cylinder(r=8.1/2/cos(30),4,center=false,$fn=6);
		 translate([0,0,4])cylinder(r=5/2,20,center=false,$fn=30);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//// Printing Stuff
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if (print_Lower == 1){
	lowerCase();
} else if(showAssy == 1) {
	color([0.8,0.4,0.1,1])
	lowerCase();
}

if (print_Upper == 1){
	upperCase();
} else if(showAssy == 1) {
	if (!(explode == 1)) {
		translate([0,0,32]) rotate([180,0,90])
		color([0.1,0.1,0.9,1])
		upperCase();
	} else {
		translate([0,0,32+50]) rotate([180,0,90])
		color([0.1,0.1,0.9,1])
		upperCase();
	}
}

if (print_Rotor == 1){
	rotor();
} else if(showAssy == 1) {
	if (!(explode == 1)) {
		color([0.1,0.8,0.1,1])
		translate([0,0,4]) 
		rotor();
	} else {
		color([0.1,0.8,0.1,1])
		translate([0,0,4+25])
		rotor();
	}
}

if (print_Output == 1){
	translate([0,0,15.5])
	rotate([0,180,0])
	outputBlock();
} else if(showAssy == 1) {
	if (!(explode == 1)) {
		color([0.4,0.4,0.1,1])
		translate([0,0,10.5]) 
		outputBlock();
	} else {
		color([0.4,0.4,0.1,1])
		translate([0,0,10.5+35]) 
		outputBlock();
	}
}

if (print_Input == 1){
	inputShaft();
} else if(showAssy == 1) {
	if (!(explode == 1)) {
		color([1,0,0,1])
		translate([-1.5,0,4]) 
		inputShaft();
	} else {
		color([1,0,0,1])
		translate([-1.5,0,4+10]) 
		inputShaft();
	}
}

if (show_bearings == 1){
	if (!(explode == 1)) {
		color([0.2,0.2,0.2,0.5])
		translate([-1.5,0,5]) 
		bearing10x15x4(clearance=0);
		
		color([0.2,0.2,0.2,0.5])
		translate([-1.5,0,11]) 
		bearing10x15x4(clearance=0);
		
		color([0.2,0.2,0.2,0.5])
		translate([0,0,15.5]) 
		bearing5x10x4(clearance=0);
		
		color([0.2,0.2,0.2,0.5])
		translate([0,0,27]) 
		bearing5x10x4(clearance=0);
	} else {
		color([0.2,0.2,0.2,0.8])
		translate([-1.5,0,5+20]) 
		bearing10x15x4(clearance=0);
		
		color([0.2,0.2,0.2,0.8])
		translate([-1.5,0,11+30]) 
		bearing10x15x4(clearance=0);
		
		color([0.2,0.2,0.2,0.8])
		translate([0,0,15.5+35]) 
		bearing5x10x4(clearance=0);
		
		color([0.2,0.2,0.2,0.8])
		translate([0,0,27+50]) 
		bearing5x10x4(clearance=0);
	}
}

if (show_bolts == 1){
	if (!(explode == 1)) {
		color([1,0,0,1])
		translate([0,0,22.5]) rotate([0,0,0])
		M5bolt();
	} else {
		color([1,0,0,1])
		translate([0,0,22.5+40]) rotate([0,0,0])
		M5bolt();
	}
}

if (showMotor == 1) {
	if (!(explode == 1)) {
		color([0.5,0.6,0.6,1])
		translate([-18,18,0]) rotate([180,0,0])
		NEMA14(show_mot = 1);
	} else {
		color([0.5,0.6,0.6,1])
		translate([-18,18,0-10]) rotate([180,0,0])
		NEMA14(show_mot = 1);
	}
}
