// original source: /r/openscad/comments/l2rc69/drawing_asymmetric_polygons/

sides = 100;
radius1 = 15;
radius2 = 17;
right_scale = 2;
front_scale = 0.9;
top_scale = 1;
bottom_scale = 1;

function x_scale(x) = x > 0 ? right_scale : front_scale;
function y_scale(y) = y > 0 ? top_scale : bottom_scale;
function x1(radius1, angle) = (radius1*cos(angle))*x_scale(radius1*cos(angle));
function y1(radius1, angle) = (radius1*sin(angle))*y_scale(radius1*sin(angle));
function x2(radius2, angle) = (radius2*cos(angle))*x_scale(radius2*cos(angle))+5;
function y2(radius2, angle) = (radius2*sin(angle))*y_scale(radius2*sin(angle))+10;

point_x1 = [for(i=[0:sides-1]) x1(radius1, i*(360/sides))]; 
point_y1 = [for(i=[0:sides-1]) y1(radius1, i*(360/sides))];
point_x2 = [for(i=[0:sides-1]) x2(radius2, i*(360/sides))]; 
point_y2 = [for(i=[0:sides-1]) y2(radius2, i*(360/sides))];    
points_p1 = [for(i=[0:sides-1]) [point_x1[i], point_y1[i]]];
points_p2 = [for(i=[0:sides-1]) [point_x2[i], point_y2[i]]];

// approach with modelling different parts


    linear_extrude(1){
        union(){
            translate([-80,-10,0])
                color("blue")
                rotate([0,0,70])
            polygon(points_p2, paths=[[0,1]], 10);

            color("green")
            hull(){    
            translate([-77,18,0])
                scale([1,1.2,1])
                circle(12, $fn=12);
                sphere(12);
            translate([-65,26,0])
                rotate([0,0,-10])
                circle(10, $fn=60);    
            }
          
            color("black")
            hull(){
            translate([-62,25,0])
                rotate([0,0,-10])
                circle(10, $fn=60);
                //square([50,20], true);
            translate([-35,15,0])
                circle(5);
            }

            color("violet")
            hull(){
            translate([-32,14,0])
                circle(5);
            translate([-25,10,0])
                scale([1,1.7,1])
                circle(5);
            translate([-14,9,0])
                scale([1,1.7,1])
                circle(5);     
            }

            color("red")
            hull(){
                rotate([0,0,165])
                    polygon(points_p1, paths=[[0,1]], 10);
                translate([-10,10,0])
                    circle(2);
            }    
        }
    }

hull(){
    linear_extrude(1){
            translate([-80,-10,0])
                color("blue")
                rotate([0,0,70])
            polygon(points_p2, paths=[[0,1]], 10);
    }
    translate([-87,5,6])
    rotate([1,1,1])
    scale([1.5,1.5,0.75])
    sphere(12);
}
/*translate([0,0,10])
linear_extrude(1){
  union(){  
    hull(){
    translate([-80,-10,0])
        color("blue")
        rotate([0,0,70])
        polygon(points_p2, paths=[[0,1]], 10);
    
    color("red")
        rotate([0,0,165])
            polygon(points_p1, paths=[[0,1]], 10);
        translate([-10,10,0])
            circle(2);
    } 

    color("green")
    hull(){    
    translate([-77,18,0])
        scale([1,1.2,1])
        circle(12, $fn=12);
    translate([-65,26,0])
        rotate([0,0,-10])
        circle(10, $fn=60);    
    }

    color("black")
    hull(){
    translate([-62,25,0])
        rotate([0,0,-10])
        circle(10, $fn=60);
        //square([50,20], true);
    translate([-35,15,0])
        circle(5);
    }

    color("violet")
    hull(){
    translate([-32,14,0])
        circle(5);
    translate([-25,10,0])
        scale([1,1.7,1])
        circle(5);
    translate([-14,9,0])
        scale([1,1.7,1])
        circle(5);     
    }
  }
    }*/

