sides = 100;
radius1 = 20;
radius2 = 10;
right_scale = 2.5;
front_scale = 1.2;
top_scale = 0.5;
bottom_scale = 0.8;

function x_scale(x) = x > 0 ? right_scale : front_scale;
function y_scale(y) = y > 0 ? top_scale : bottom_scale;
function x1(radius1, angle) = (radius1*cos(angle))*x_scale(radius1*cos(angle));
function y1(radius1, angle) = (radius1*sin(angle))*y_scale(radius1*sin(angle));
function x2(radius2, angle) = (radius2*cos(angle))*x_scale(radius2*cos(angle))+5;
function y2(radius2, angle) = (radius2*sin(angle))*y_scale(radius2*sin(angle))+10;

point_x1 = [for(i=[0:sides-1]) x1(radius1, i*(360/sides))]; 
point_y1 = [for(i=[0:sides-1]) y1(radius1, i*(360/sides))];
point_x2 = [for(i=[0:sides-1]) x2(radius2, i*(360/sides))]; 
point_y2 = [for(i=[0:sides-1]) y2(radius2, i*(360/sides))];    
points_p1 = [for(i=[0:sides-1]) [point_x1[i], point_y1[i]]];
points_p2 = [for(i=[0:sides-1]) [point_x2[i], point_y2[i]]];


// approach with cutting out parts

difference(){
    polygon(points_p1, paths=[[0,1]], 10);
    translate([8,14,0])
        scale([1.6,1,1])
        circle(12);
}