// original source: /r/openscad/comments/l2rc69/drawing_asymmetric_polygons/

sides = 500;
radius = 20;
right_scale = 2.7;
front_scale = 1.2;
top_scale = 0.9;
bottom_scale = 1;
$fn=50;

function x_scale(x) = x > 0 ? right_scale : front_scale;
function y_scale(y) = y > 0 ? top_scale : bottom_scale;
function x(radius, angle) = (radius*cos(angle))*x_scale(radius*cos(angle));
function y(radius, angle) = (radius*sin(angle))*y_scale(radius*sin(angle));

point_x = [for(i=[0:sides-1]) x(radius, i*(360/sides))]; 
point_y = [for(i=[0:sides-1]) y(radius, i*(360/sides))];
points = [for(i=[0:sides-1]) [point_x[i], point_y[i]]];

hull(){
    linear_extrude(2){
        polygon(points, paths=[[0,1]], 10);
    }  
        translate([28,4,10])
            scale([2.6,1,1])
            sphere(10);
}


