// notes
    //golden ratio 1:1.618
    // Vitruvian man 3.75:6.25
    // upper vs lower body >1:1.56

//thigh
    thigh_lenght=250;
    upper_sphere_thigh=[thigh_lenght,0,0]; //thigh length
    upper_sphere_scale=[2.1,1,0.9]; //[2.1,1.1,1]
    upper_sphere_radius=50;

    back_sphere=[thigh_lenght-25,35,7]; //inner backside
    back_sphere_scale=[4,1.25,1.75];
    back_sphere_radius=30;

    inner_thight_up=[thigh_lenght-20,8,thigh_lenght/100*8+7];
    inner_thigh_low=[(thigh_lenght/2)-5,8,thigh_lenght/100*8+10];
    inner_sphere_scale=[2.5,1,1];
    //inner_sphere_scale=[2.5,1.2,1.1]; 
    inner_sphere_radius=back_sphere_radius+2;

    mid_sphere=[60,15,thigh_lenght/100*8];
    mid_sphere_scale=inner_sphere_scale;   
    mid_sphere_radius=30;

    low_sphere=[5,10,30];
    low_sphere_radius=20;
    low_sphere_scale=[1,1,1.4];

    thigh2_offset=[0,0,-140];
    
// butt
    butt_mid_sphere=upper_sphere_thigh+[40,20,5];
    butt_mid_sphere_scale=[1.5,1.2,0.95];
    butt_mid_sphere_rad=upper_sphere_radius-1;
    //smoothing edges and inner side
    butt_inner_sphere=upper_sphere_thigh+[10,-5,2];
    butt_inner_sphere_scale=[1.9,0.9,0.97];
    //backside
    butt_back_sphere=upper_sphere_thigh+[45,35,15];
    butt_back_sphere_scale=[1.6,1.2,1.2];
    butt_back_sphere_rad=47;
    //smooting, nearly same than upper part of thigh
    butt_front_sphere=upper_sphere_thigh+[30,0,0];
    butt_front_sphere_scale=upper_sphere_scale-[0.8,0.2,0.1];
    butt_front_sphere_rad=upper_sphere_radius+4;

// lower torso
    x_offs=-10;
    y_pos=-20;
    upr_body_scale=1.5;
    upr_waist_scale=1.1;
    ribcage_size=26;
    lower_torso_length = thigh_lenght*upr_body_scale+x_offs+(thigh_lenght/2);
    lower_torso_bottom = thigh_lenght*upr_body_scale+x_offs-80;
    lower_torso_top = lower_torso_bottom/3;  
    uppr_lower_torso_zpos = thigh_lenght/3.4482; // div 2 - 52.5
    belly_zpos = thigh_lenght/3.57; // div 2 - 55 or 3.57 
    kidney_area_back = 36;
    naval_hipbone_xpos = lower_torso_bottom+100;
    // note: hip bone needs to be adjusted

// upper torso
    upper_torso_xpos = thigh_lenght*2.35;
    upper_torso_wdth = (thigh_lenght*upr_body_scale)/5;
    upper_torso_ypos = y_pos+(0*upr_body_scale);
    shoulder_with = 15; // 15-25

// back muscles
    torso_thickness=belly_zpos;
    spine_muscl_dist=35; // lower is more
    spine_muscl_hight=thigh_lenght+x_offs+320;

// hip area
    hip_sphere_side = 27;
    hip_sphere_hight = thigh_lenght+x_offs+100;
    hip_y_dist = y_pos+torso_thickness-27;
    hip_sphere_scale = [2,0.9,1.4];
    hip_sphere_angle = 35;
    middle_sphere_pos = 70;

$fn=65;
final_color="pink";
//final_color="violet";
//final_color="lightgrey";

module ribcage_sphere(size=26,length=3,left=1){
        color("orange")
        rotate([0,shoulder_with*left,5])
        scale([length,1,length/2])
        sphere(size*upr_body_scale); 
}
module xmirror(copy=false,condition=false){
	if(condition){
		mirror([1,0,0])
		children();
		
		if(copy){
			children();
		}
	}else{
		children();
	}
}

module butt_sphere(){
    hull(){
        translate(butt_mid_sphere)
            color("red")
            scale(butt_mid_sphere_scale)
            sphere(butt_mid_sphere_rad);
        //smoothing edges and inner side    
        translate(butt_inner_sphere)
            color("blue")
            scale(butt_inner_sphere_scale)
            sphere(upper_sphere_radius);
        //backside
        translate(butt_back_sphere)
            scale(butt_back_sphere_scale)
            color("green")
            sphere(butt_back_sphere_rad);
        //smooting, nearly same than upper part of thigh     
        translate(butt_front_sphere)
            color("cyan")
            scale(butt_front_sphere_scale)
            sphere(butt_front_sphere_rad);     
    }
}
module thight(){
    hull(){
        //  
        translate(upper_sphere_thigh)
            scale(upper_sphere_scale)
            sphere(upper_sphere_radius);   
        //
        translate(back_sphere)
            scale(back_sphere_scale)
            sphere(back_sphere_radius);
        //
        hull(){
            translate(inner_thight_up)
                scale(mid_sphere_scale)    
                sphere(inner_sphere_radius);
            //
            translate(inner_thigh_low)
                scale(inner_sphere_scale)    
                sphere(inner_sphere_radius);
        }      
        //
        translate(mid_sphere)
            scale(mid_sphere_scale)    
            sphere(mid_sphere_radius);
        //
        translate(low_sphere)
            scale(low_sphere_scale)
            sphere(low_sphere_radius); 
    }    
}
module copy_mirror(vec=[0,1,0]){   
    children();
    mirror(vec) children();
} 

module lower_leg(){
        hull(){
        translate(low_sphere+[-15,5,-2])
            color("green")
            //scale(low_sphere_scale+[0,-0.2,-0.2])
            sphere(low_sphere_radius+5);
        translate(low_sphere+[-15,4,15])
            color("yellow")
            scale([3,1.5,1])
            sphere(low_sphere_radius/2);    

        translate(low_sphere+[5,0,10])
            color("violet")
            scale(low_sphere_scale+[0,0,0])
            sphere(12);    
        //muscles    
        translate(low_sphere+[-75,17,8])
            color("blue")
            scale([3.2,1.2,1.2])
            sphere(23);

        translate(low_sphere+[-260,10,12])
            color("red")
            scale([1,1,1])
            sphere(12);
        }   
}
module kidney_area(){
    color("blue")
    rotate([0,-15,0])
    scale([2.5,0.4,1.25])
    sphere(3*upr_body_scale); 
    }
module kidney_area_back(angle=15){
        color("blue")
        rotate([0,angle,0])
        scale([1.8,0.4,0.9])
        sphere(kidney_area_back*upr_body_scale);
}
module kidney_area_front(angle=15){
        color("lightblue")
        rotate([0,angle,0])
        scale([2.5,0.4,1.25])
        sphere(7*upr_body_scale);
    }
        
module back_muscle(multiplier=1){
    hull(){
        translate([spine_muscl_hight,
                    y_pos+torso_thickness-20,
                    spine_muscl_dist*multiplier])
            color("blue")
            scale([4,1,1.2])
            sphere(20.4*upr_body_scale);
    }
}
module hip_bone_spike(position=thigh_lenght/2+19){
    translate([naval_hipbone_xpos,y_pos+1,position])
        color("orange")
        scale([1,0.5,1])
        sphere(17*upr_body_scale);
}
// knee mechanism example placeholder
/*color("blue")
translate([0,15,4])
    linear_extrude(50)
    circle(20);*/

// crutch
translate([thigh_lenght+x_offs+70,5,70])
    color("purple")
    scale([1,1,1.5])
    sphere(30);
// naval
color(final_color)
difference(){
    color(final_color)
    hull(){
        // belly area 
        translate([lower_torso_length,(y_pos-2)*upr_body_scale,uppr_lower_torso_zpos])
            scale([2,0.5,upr_waist_scale+0.4])
            color("grey")
            sphere(32*upr_body_scale);         
        // lower belly area
        translate([lower_torso_bottom+80,(y_pos+4)*upr_body_scale,belly_zpos])
            scale([2.5,0.55,1.5])
            color("lightgrey")
            sphere(17*upr_body_scale);
        // belly area (front area)
        translate([lower_torso_length,(y_pos-9)*upr_body_scale,uppr_lower_torso_zpos])
            scale([2.5,0.5,upr_waist_scale+0.4])
            color("blue")
            sphere(25*upr_body_scale);         
        // lower belly area (front area)
        translate([lower_torso_bottom+80,(y_pos+4)*upr_body_scale,belly_zpos])
            scale([2.5,0.5,1.5])
            color("lightblue")
            sphere(12*upr_body_scale);
        // kidney area left
        translate([thigh_lenght+x_offs+100,y_pos-5,20])
            kidney_area();           
        // kidney area right
        translate([thigh_lenght+x_offs+100,y_pos-5,thigh_lenght/2-7])
            kidney_area(); 
    }

   
        translate([naval_hipbone_xpos,(y_pos-14)*upr_body_scale,belly_zpos+2])
            scale([1,1,1])
            color("black")
            sphere(4*upr_body_scale);
}
// upper torso
    // upper_torso_xpos = thigh_lenght*upr_body_scale+x_offs;
color(final_color)
hull(){
    translate([upper_torso_xpos-20,upper_torso_ypos,belly_zpos+3])
        scale([2.5,0.55,1.5])
        color("yellow")
        sphere(ribcage_size*1.4*upr_body_scale);
    // right ribcage
        translate([upper_torso_xpos,upper_torso_ypos,upper_torso_wdth*upr_body_scale])
            ribcage_sphere(size=ribcage_size,left=-1);
    // left ribcage
        translate([upper_torso_xpos,upper_torso_ypos,belly_zpos/2])
        ribcage_sphere(size=ribcage_size);
}
// upper torso back side
     // right side
color(final_color)
hull(){
    // right ribcage
    translate([upper_torso_xpos,upper_torso_ypos,upper_torso_wdth*upr_body_scale])
        ribcage_sphere(size=ribcage_size,left=-1);
    // back muscle left side
    color(final_color)
    back_muscle(multiplier=3);
}
color(final_color)
    // left side
hull(){    
    // left ribcage
    translate([upper_torso_xpos,upper_torso_ypos,belly_zpos/2])
        ribcage_sphere(size=ribcage_size);
    // left back muscle
    color(final_color)
    back_muscle(multiplier=1);
} 
// kidney area
    // left side
color(final_color)
hull(){
    // kidney area front left
    translate([thigh_lenght+x_offs+150,y_pos-10,5])
    kidney_area_front(-15);
    //upper thigh sphere
    translate(upper_sphere_thigh)
        scale(upper_sphere_scale)
        sphere(upper_sphere_radius); 
    // kidney area back left
    translate([thigh_lenght*1.5+x_offs,y_pos+10,5])
kidney_area_back(-15);
    // venus area left
    translate([thigh_lenght+x_offs+100,y_pos+2.5,30])
        color("blue")
        scale([1,1,1])
        sphere(8*upr_body_scale);
    // hip bone spike left
    hip_bone_spike(position=-5);
} 

    // right side
color(final_color)
hull(){
    // kidney area front right
    translate([thigh_lenght+x_offs+150,y_pos-10,thigh_lenght/2+10])
    kidney_area_front(15);
    //upper thigh sphere
    mirror([0,0,90]){
    translate(thigh2_offset)
            translate(upper_sphere_thigh)
                scale(upper_sphere_scale)
                sphere(upper_sphere_radius);}     
    // kidney area back right
    translate([thigh_lenght*1.5+x_offs,y_pos+10,thigh_lenght/2+10])
        kidney_area_back(15);
    // venus area right
    translate([thigh_lenght+x_offs+100,y_pos+2.5,thigh_lenght/2+20-35])
        color("blue")
        scale([1,1,1])
        sphere(8*upr_body_scale);    
    // hip bone spike right
    hip_bone_spike(position=thigh_lenght/2+19);
}

//  backside - spine muscles
color(final_color)
    // back muscle left side 
    back_muscle(multiplier=1);
color(final_color)
    // back muscle left side 
    back_muscle(multiplier=3);
// hips
    // right
color(final_color)
hull(){
    // right hip backside 
    translate([hip_sphere_hight,hip_y_dist,spine_muscl_dist*3])
        color("blue")
        scale(hip_sphere_scale)
        rotate([0,hip_sphere_angle,0])
        sphere(hip_sphere_side*upr_body_scale);
    
    // hip center 
    translate([hip_sphere_hight+80,hip_y_dist,middle_sphere_pos])
        color("blue")
        scale(hip_sphere_scale)
        rotate([0,hip_sphere_angle*-1,0])
        sphere(hip_sphere_side/3*upr_body_scale);
}
    // left
color(final_color)
hull(){
    // left hip backside 
    translate([hip_sphere_hight,hip_y_dist,spine_muscl_dist])
        color("blue")
        scale(hip_sphere_scale)
        rotate([0,hip_sphere_angle*-1,0])
        sphere(hip_sphere_side*upr_body_scale);

    // hip center 
    translate([hip_sphere_hight+80,hip_y_dist,middle_sphere_pos])
        color("blue")
        scale(hip_sphere_scale)
        rotate([0,hip_sphere_angle*-1,0])
        sphere(hip_sphere_side/3*upr_body_scale);
}


// buttocks
    //left buttock
    color(final_color)    
    butt_sphere();
    //right buttock
    color(final_color)
    mirror([0,0,90]){
        translate(thigh2_offset)    
        butt_sphere();
    }
// thights
    //left thigh
    color(final_color)
        thight();
    //right thigh
    color(final_color)
mirror([0,0,90]){
    translate(thigh2_offset)
        thight();
}

// lower legs
    //left
    color(final_color)
    lower_leg();
    //right
    translate([0,0,140])
        color(final_color)
        mirror([0,0,90]){
            lower_leg();
        }


